/* rwsem.h: R/W semaphores, public interface
 *
 * Written by David Howells (dhowells@redhat.com).
 * Derived from asm-i386/semaphore.h
 */

#ifndef _LINUX_RWSEM_H
#define _LINUX_RWSEM_H

struct rw_semaphore {
};

#define DECLARE_RWSEM(X) struct rw_semaphore X

/*
 * lock for reading
 */
static inline void down_read(struct rw_semaphore *sem)
{
}

/*
 * trylock for reading -- returns 1 if successful, 0 if contention
 */
static inline int down_read_trylock(struct rw_semaphore *sem)
{
	return 1;
}

/*
 * lock for writing
 */
static inline void down_write(struct rw_semaphore *sem)
{
}

/*
 * trylock for writing -- returns 1 if successful, 0 if contention
 */
static inline int down_write_trylock(struct rw_semaphore *sem)
{
	return 1;
}

/*
 * release a read lock
 */
static inline void up_read(struct rw_semaphore *sem)
{
}

/*
 * release a write lock
 */
static inline void up_write(struct rw_semaphore *sem)
{
}

/*
 * downgrade write lock to read lock
 */
static inline void downgrade_write(struct rw_semaphore *sem)
{
}

#endif /* _LINUX_RWSEM_H */
